package com.logicbig.example;

import com.logicbig.example.bean.EventListener;
import com.logicbig.example.bean.EventManager;
import com.logicbig.example.bean.EventPublisher;
import org.springframework.context.annotation.*;

@Configuration
@ComponentScan("com.logicbig.example")
public class AppConfig {

    @Bean
    @DependsOn("eventListenerBean")
    public EventPublisher eventPublisherBean() {
        return new EventPublisher();
    }

    @Bean
    public EventListener eventListenerBean() {
        return new EventListener();
    }

    @Bean
    public EventManager eventManagerBean() {
        return new EventManager();
    }

    public static void main(String... strings) {
        AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext(AppConfig.class);
        context.close();

    }
}